
// variables
String buffer = "";                                           // empty string to store incoming serial data -- a buffer
char inByte, inByte2;                                         // incoming byte from serial RX port0 and port2
boolean stringComplete = false;                               // whether the string is complete or not
int EnableVal;
int ALONE_MODE;
String test, test_akt;
bool Monitor;
int TRX_Mode, Akt_Band,New_Band,LoopCount;
  
// IO port definition for bands
int b160 = 27;
int b80 = 33;
int b6040 = 22;
int b3020 = 21;
int b1715 = 19;
int b1210 = 5;
int b0604 = 2;

void(* resetFunc) (void) = 0;                                 //declare reset function at address 0
unsigned long currentMillis, previousMillis;

void setup() {
  //configure pin 32 and pin 25 as an input and enable the internal pull-up resistors
  pinMode(32,INPUT_PULLUP);                                   //enable
  pinMode(25,INPUT_PULLUP);                                   //alone mode
  Monitor=false;                                              //Monitor in der Arduino-IDE
  TRX_Mode=0;
  LoopCount=0;

  if (Monitor==true){
    Serial.write("Hello World");
    Serial.write("\n");
  }
  
  //configure the follow pins as an output
  pinMode(b160,OUTPUT);
  pinMode(b80,OUTPUT);
  pinMode(b6040,OUTPUT);
  pinMode(b3020,OUTPUT);
  pinMode(b1715,OUTPUT);
  pinMode(b1210,OUTPUT);
  pinMode(b0604,OUTPUT);

  test_akt="";
  Akt_Band=0;
  
  //set at start all output to LOW
  ResetOutput();
 
  //start serial connection
  Serial.begin(38400);                                        // ---> Laptop
  Serial2.begin(38400);                                       // ---> PICaStar
  
  buffer.reserve(64);                                         // reserve 64 bytes for the incoming data buffer; UARTS's buffer is only 64 bytes long... :-P
  
  Serial2.write("IF;");   
}

void loop() {
  EnableVal = digitalRead(32);
  ALONE_MODE = digitalRead(25);
  
  currentMillis = millis();                                   // refresh counter variable
  previousMillis = currentMillis;
    
  if((ALONE_MODE == LOW) ||(!Serial.available() )){           //entweder hart gesetzt oder Laptop hat nichts zu sagen
    //Kommando an den Trx, seinen Status zu übermitteln
    Serial2.write("IF;");                                     //send "IF" to PICaStar
    if (Monitor==true){
    //   Serial2.write("\n");
    //   Serial.write("IF an PICaSTAR;");                     //send "IF" to PICaStar
    //   Serial.write("\n");
    }
    // wait for the transmission of outgoing serial data from the Arduino to the radio to be completed
    Serial2.flush();  
  }
  // we don't have to be always polling the radio frequency...we can wait for a while...XD 
  delay(50);   //30

  // get the first byte          
  if (Serial2.available() ) {                                  //read PICaStar
      inByte2 = (char) Serial2.read(); 
      if (Monitor==true){
      //      Serial.write("PICaStar meldet sich;"); 
      //      Serial.write("\n");
      }
      else{
        Serial.write(inByte2);                                 //PICaStar ---> weiterleiten an LapTop
      }
  } else {
    // clear the RX buffer
    buffer = "";
    stringComplete = false;  
  }
 
  // when the first byte is 'I' then we have to continue reading the input data 
  // Der Trx muss seine Antwort mit einem 'I' beginnen
  if (inByte2 == 'I') {
    if (Monitor==true){
      //  Serial.write("Erstes Byte ist ein 'I';");
    }
    stringComplete = false;
    buffer  += inByte2; 
    while (Serial2.available()) {
      inByte2 = (char) Serial2.read();
      Serial.write(inByte2);                                    //PICaStar ---> weiterleiten an LapTop 
      buffer += inByte2; 
      // the reading procedure finishes when we read the ';' character
      if (inByte2 == ';') {
        stringComplete = true; 
      }
    }
  }else{
    while (Serial2.available()) {
      inByte2 = (char) Serial2.read();
      Serial.write(inByte2);                                    //PICaStar ---> weiterleiten an LapTop
    }  
  }
  Serial2.flush();
  
  // update band output only if the complete data has been received 
  if (stringComplete) {  
    if (EnableVal == LOW) {                                     //wenn durch Drehschalter an der PA angewählt 
      WriteBand(); 
    }else{
      if (TRX_Mode==0){                                         //bei Senden kein Reset erlauben
        ResetOutput();
      }
    }   
    // clear the RX buffer
    buffer = "";
    stringComplete = false;
  } 
  
  

  // read from port 0, send to port 2:                          //read Laptop,  wird benötigt, damit z. B. Logprogramme  a u c h  den Status des Trx abfragen können
  if (Monitor==false){
    while (Serial.available()) {                                //Falls Laptop was zu sagen hat
      inByte = Serial.read();                                   //vom Laptop lesen
      Serial2.write(inByte);                                    //Laptop ---> weiterleiten an PICaStar
    }
    Serial.flush();
  }
  
  delay(10);          //10
}

void WriteBand(){
  String str_if= buffer;
  String qrg,str_TRX_Mode;

  ReadQRG();
  
  
  str_TRX_Mode=str_if.substring(28,29);
  if (str_TRX_Mode[0]=='1'){
    // Serial.write("TX");
    // Serial.write("\n");
    TRX_Mode=1;
  }else{
    // Serial.write("RX");
    // Serial.write("\n");
    TRX_Mode=0;
  }
  if (TRX_Mode==0){                                 // nur bei Empfang Bandwechsel erlauben
    if (New_Band!=Akt_Band){                       // nur wenn neuer Bandwert
      LoopCount=LoopCount+1;                       //kurzzeitige Fehl-Werte unter 200ms Dauer verhindern
      if (LoopCount==4){                          
        LoopCount=0;
        Akt_Band=New_Band;   
        //160m 
        if (New_Band==160)
        {
          digitalWrite(b160,HIGH);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,LOW); 
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 160");
              Serial.write("\n");
              test_akt=test;
            }
          }
        }

        // 80m band
        if (New_Band==80)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,HIGH);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,LOW); 
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 80");
              Serial.write("\n");
              test_akt=test;
            }
          }
        }

        // 60m und 40m band
        if (New_Band==6040)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,HIGH);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,LOW); 
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 6040");
              Serial.write("\n");
              test_akt=test;
            }
          }   
        }

        // 30m und 20m band
        if (New_Band==3020)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,HIGH);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,LOW);
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 3020");
              Serial.write("\n");
              test_akt=test;
            }
          }     
        }

        // 17m und 15m band
        if (New_Band==1715)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,HIGH);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,LOW);
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 1715");
              Serial.write("\n");
              test_akt=test;
            }
          }
        }

        // 12m und 10m band
        if (New_Band==1210)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,HIGH);
          digitalWrite(b0604,LOW);
          if (Monitor==true){ 
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 1210");
              Serial.write("\n");
              test_akt=test;
            }
          }
        }

        // 6m und 4m band
        if (New_Band==0604)
        {
          digitalWrite(b160,LOW);
          digitalWrite(b80,LOW);
          digitalWrite(b6040,LOW);
          digitalWrite(b3020,LOW);
          digitalWrite(b1715,LOW);
          digitalWrite(b1210,LOW);
          digitalWrite(b0604,HIGH);
          if (Monitor==true){
            if (test!=test_akt){
              Serial.print(test);
              Serial.write(" - 0604");
              Serial.write("\n");
              test_akt=test;
            }
          }  
        }  
      }
    }else{
      LoopCount=0;  
    }
  }else{
    delay(10);
  }
}

void ResetOutput(){
  digitalWrite(b160,LOW);
  digitalWrite(b80,LOW);
  digitalWrite(b6040,LOW);
  digitalWrite(b3020,LOW);
  digitalWrite(b1715,LOW);
  digitalWrite(b1210,LOW);
  digitalWrite(b0604,LOW);   
}
void ReadQRG(){
  String str_if= buffer;
  String qrg;

  // Frequenz wird übertragen in Byte 5 bis Byte 10
  qrg = str_if.substring(5,10);

  //160m 
  if ((qrg[0] == '0') && (qrg[1] == '1'))
  {
    New_Band=160;
  }

  // 80m band
  if (((qrg[0] == '0') && (qrg[1] == '2')) || ((qrg[0] == '0') && (qrg[1] == '3')))
  {
    New_Band=80;
  }
  
  // 60m und 40m band
   if (((qrg[0] == '0') && (qrg[1] == '4')) || ((qrg[0] == '0')&& (qrg[1] == '5'))|| ((qrg[0] == '0')&&(qrg[1] == '6')) || ((qrg[0] == '0')&& (qrg[1] == '7')))
   {
    New_Band=6040;
   }

   // 30m und 20m band
   if (((qrg[0] == '0') && (qrg[1] == '8'))|| ((qrg[0] == '0')&& (qrg[1] == '9'))|| ((qrg[0] == '1')&& (qrg[1] == '0'))|| ((qrg[0] == '1')&&(qrg[1] == '1'))|| ((qrg[0] == '1')&& (qrg[1] == '2'))||((qrg[0] == '1')&& (qrg[1] == '3'))|| ((qrg[0] == '1')&& (qrg[1] == '4')))
   {
    New_Band=3020;
   }

   // 17m und 15m band
   if (((qrg[0] == '1') && (qrg[1] == '5'))|| ((qrg[0] == '1')&& (qrg[1] == '6'))|| ((qrg[0] == '1')&& (qrg[1] == '7'))|| ((qrg[0] == '1')&&(qrg[1] == '8'))|| ((qrg[0] == '1')&& (qrg[1] == '9'))||((qrg[0] == '2')&& (qrg[1] == '0'))|| ((qrg[0] == '2')&& (qrg[1] == '1')))
   {
    New_Band=1715;
   }

   // 12m und 10m band
   if (((qrg[0] == '2') && (qrg[1] == '2'))|| ((qrg[0] == '2')&& (qrg[1] == '3'))|| ((qrg[0] == '2')&& (qrg[1] == '4'))|| ((qrg[0] == '2')&&(qrg[1] == '5'))|| ((qrg[0] == '2')&& (qrg[1] == '6'))||((qrg[0] == '2')&& (qrg[1] == '7'))|| ((qrg[0] == '2')&& (qrg[1] == '8'))|| ((qrg[0] == '2')&& (qrg[1] == '9')))
   {
    New_Band=1210;
   }

   // 6m und 4m band
   if ((qrg[0] == '3') || (qrg[0] == '4')||(qrg[0] == '5')|| (qrg[0] == '6')|| (qrg[0] == '7'))
   {
    New_Band=0604;
   }
}
/*
      //Evtl. für TimeOut-Bahandlung benutzen
      currentMillis=millis();
      if (currentMillis - previousMillis > 1000){
        resetFunc();                                              //call ResetFunc
      }
 */
